<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


include_once("obj_Rule.php");
include_once("func_Log.php");


function GetNextAvals_sid($sid_series)
	{
	global $db;

	$sid = 0;
	
	if($sid_series != "")
		{
		$sid_min = $sid_series;
		$sid_max = $sid_series+1000000;
		}
	else
		{
		$sid_min = 1000000;
		$sid_max = 100000000;
		}
	

	$sql ="SELECT max(sid)+1 as nextsid FROM TBL_RULES where sid < $sid_max";
	$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
	$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
	$sid = $row['nextsid'];	
	$result->free();

	if ($sid < $sid_min)
		{ $sid = $sid_min; }

	return ($sid);
	}

	





function StoreRule($cata,$rule,$notes)
	{
	global $db;	

	/*** Get todays date ***/
	$todaydate = date("Y-m-d H:i:s");

	/*** Get rule revision number, if none set one ***/
	$rev = $rule->GetOption("rev");
	if ($rev == "")
		{
		$rev = 1;
		$rule->SetOption("rev",$rev);
		}
		
	/*** Check if rule has a sid, if not give it one ***/
	$sid = $rule->GetOption("sid");
	if ($sid == "")
		{
		$sid = GetNextAvals_sid();
		$rule->SetOption("sid",$sid);
		}
	$ruletext = mysql_escape_string($rule->GenRule());
	$rulename = mysql_escape_string($rule->GetOption("msg"));

	/*** check if rule already in database  ***/
	$sql = "select sid FROM TBL_RULES WHERE sid = " . $sid;
	$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}

	if ($result->numRows() == 1)
		{
		/*** Update ***/
		$sql =	"UPDATE		TBL_RULES ".
				"SET	".
				"	lastupdate = '".$todaydate."', ".
				"	cata = '".$cata."', ".
				"	name = '".$rulename."', ".
				"	notes = '".$notes."', ".
				"	rev = '".$rev."', ".
				"	rule = '".$ruletext."' ".
				" WHERE sid = ".$sid;
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "update";		
		}
	else
		{
		/*** Insert ***/
		$sql = 	"INSERT INTO TBL_RULES ".
				"(sid, lastupdate, cata, name, rule, notes, rev) ".
				"VALUES($sid, '$todaydate', '$cata', '$rulename', '$ruletext', '$notes', '$rev')";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "new";			
		}
		
	return $return;
	}



function InsertRules($cata,$lines)
	{
	?>
	<table border="0" class="combo1"><tr><td>
	<table border="0" cellspacing="1">
	<tr><th colspan="3" class="combo1">Imported Rules</th></tr>
	<tr class="combo2"><th align="center">Action</th><th>Catagory</th><th>Post Proccesed Rule</th></tr>
	<?

	$linenum = 0;
	foreach ($lines as $line)
		{
		$linenum++;
		if ( 
			(!preg_match("/^#/",$line)) &&			/* Skip comment lines */
			($line != "") &&						/* Skip empty lines */
			(preg_match("/[A-Z|a-z|0-9]+/",$line))	/* Skip blank lines */
			)
			{	
			// print"<pre>-".$line."-</pre>";
			$rule = New Rule();

			if ($rule->Parse($line))
				{		
				$ruletext = $rule->GenRule();
				$result = StoreRule($cata,$rule,"");
				$status = "Imported ($result)";
				$color = "Green";
				
				}
			else
				{		

				//$rule->ShowTree();
				
				
				$status = "Rejected";
				$color = "Red";
				$errors = $rule->Get("error");
				$ruletext = "&lt;ERRORS&gt; ";
				foreach($errors as $item) { $ruletext .= " | " . $item; }
				$ruletext .= "<BR>" . $rule->Get("raw");
				
				LogEvent("Error: Save rule failed $errors");
				}
			$ruletext = htmlspecialchars($ruletext);
			$ruletext = wordwrap($ruletext, 100, "<br>",1);
			?>
			<tr class="bg2"><td nowrap align="center" style="color:<?=$color?>;"><B><?=$status?></B></td><td nowrap><?=$cata?></td><td><?=$ruletext?></td></tr>
			<?
			}

		}
	?>
	</table>
	</td></tr></table>
	<?
	}

	
	
function ProcessRuleFile($filename)
	{
	/** Get Catagory name from file name ***/
	preg_match("/([^\/]+)\.rules/", $filename, $matches);
	$cata = $matches[1];

	/*** Open file for reading ***/
	if($handle = fopen($filename, "r"))
		{
		$buffer = "";
	
		/*** Read entire file ***/
		while (!feof($handle))
			{
			$buffer .= fgets($handle, 4096);
			}
	
		/*** Remove Line feeds (if any) ***/
		$buffer = preg_replace("/\r/sm","",$buffer);
		/*** Concatonate lines ending in "\" ***/
		$buffer = preg_replace("/\\\\(\s+)?\n/sm"," ",$buffer);
	
		/*** Split file into array of lines ***/
		$lines = explode("\n",$buffer);
	
		/*** Add rules to database ***/
		InsertRules($cata,$lines);
	
		fclose($handle);
		}
	else
		{
		LogEvent("Error: failed to open file: $filename");
		}
	}
	

	
	
	
function StoreRef($alias,$definition)
	{
	global $db;
	$return = "Failed";	

	/*** check if class is already in database  ***/
	$sql = "select alias FROM TBL_REFERENCES WHERE alias = '" . $alias . "'";
	$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}

	if ($result->numRows() == 1)
		{
		/*** Update ***/
		$sql =	"UPDATE		TBL_REFERENCES ".
				"SET	".
				"	alias = '".$alias."', ".
				"	definition = '".$definition."' ".
				" WHERE alias = '".$alias."'";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "Imported (update)";		
		}
	else
		{
		/*** Insert ***/
		$sql = 	"INSERT INTO TBL_REFERENCES ".
				"(alias, definition) ".
				"VALUES('$alias', '$definition')";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "Imported (new)";			
		}
	return $return;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
function StoreVar($varname,$varvalue)
	{
	global $db;
	$return = "Failed";	

	/*** check if class is already in database  ***/
	$sql = "select varname FROM TBL_VARIABLES WHERE varname = '" . $varname . "'";
	$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}

	if ($result->numRows() == 1)
		{
		/*** Update ***/
		$sql =	"UPDATE		TBL_VARIABLES ".
				"SET	".
				"	varvalue = '".$varvalue."' ".
				" WHERE varname = '".$varname."'";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "Imported (update)";		
		}
	else
		{
		/*** Insert ***/
		$sql = 	"INSERT INTO TBL_VARIABLES ".
				"(varname, varvalue) ".
				"VALUES('$varname', '$varvalue')";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "Imported (new)";			
		}
	return $return;
	}
	
	
	
	
	
	
	
	
	
	
	

	

function StoreClass($shortname,$description,$priority)
	{
	global $db;
	$return = "Failed";	

	/*** check if class is already in database  ***/
	$sql = "select shortname FROM TBL_CLASSIFICATIONS WHERE shortname = '" . $shortname . "'";
	$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}

	if ($result->numRows() == 1)
		{
		/*** Update ***/
		$sql =	"UPDATE		TBL_CLASSIFICATIONS ".
				"SET	".
				"	shortname = '".$shortname."', ".
				"	description = '".$description."', ".
				"	priority = '".$priority."' ".
				" WHERE shortname = '".$shortname."'";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "Imported (update)";		
		}
	else
		{
		/*** Insert ***/
		$sql = 	"INSERT INTO TBL_CLASSIFICATIONS ".
				"(shortname, description, priority) ".
				"VALUES('$shortname', '$description', '$priority')";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "Imported (new)";		
		}
	return $return;
	}

	
function StorePre($name)
	{
	global $db;
	$return = "Failed";	

	/*** check if class is already in database  ***/
	$sql = "select preprocessor FROM TBL_PREPROCESSORS WHERE preprocessor = '" . $name . "'";
	$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}

	if ($result->numRows() == 1)
		{
		/*** Update ***/
		$return = "Ignored (exists)";
		}
	else
		{
		/*** Insert ***/
		$sql = 	"INSERT INTO TBL_PREPROCESSORS ".
				"(preprocessor) ".
				"VALUES('$name')";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$return = "Imported (New)";	
		}
	return $return;
	}

function InsertDirectives($lines)
	{
	?>
	<table border="0" class="combo1"><tr><td>
	<table border="0" cellspacing="1">
	<tr><th colspan="3" class="combo1">Imported Directives</th></tr>
	<tr class="combo2"><th align="center">Action</th><th>Type</th><th>Item</th></tr>
	<?
	
	
	$linenum = 0;
	foreach ($lines as $line)
		{
		$linenum++;
		$type = "";

		if (  (!preg_match("/^#/",$line)) && ($line != "")   )
			{
			/** Is this a classification directive? ***/
			if (preg_match("/config\sclassification\s?:\s?([^,]+),([^,]+),([^,]+)/", $line, $matches))
				{
				$type = "Classification";
				$shortname = $matches[1];
				$description = $matches[2];
				$priority = $matches[3];
				$item = $matches[0];
				//print "<br><B>FOUND -&gt;</B> config classification: $shortname,$description,$priority\n";
				$result = StoreClass($shortname,$description,$priority);
				?>
				<tr class="bg2"><td nowrap align="center" style="color:Green"><B><?=$result?></B></td><td nowrap><?=$type?></td><td><?=$item?></td></tr>
				<?

				}

			/** Is this a Reference directive? ***/
			else if (preg_match("/config\sreference\s?:\s?([^\s]+)\s(.+)/", $line, $matches))
				{
				$type = "Reference";
				$alias = trim($matches[1]);
				$definition = trim($matches[2]);
				$item = $matches[0];
				//print "<br><B>FOUND -&gt;</B> config reference: $alias $definition\n";
				$result = StoreRef($alias,$definition);
				?>
				<tr class="bg2"><td nowrap align="center" style="color:Green"><B><?=$result?></B></td><td nowrap><?=$type?></td><td><?=$item?></td></tr>
				<?

				}

			/** Is this a Preprocessor directive? ***/
			else if (preg_match("/preprocessor\s+(.+)/", $line, $matches))
				{
				$type = "Preprocessor";
				$preprocessor = trim($matches[1]);
				$item = $matches[0];
				//print "<br><B>FOUND -&gt;</B> preprocessor: $preprocessor\n";
				$result = StorePre($preprocessor);
				?>
				<tr class="bg2"><td nowrap align="center" style="color:Green"><B><?=$result?></B></td><td nowrap><?=$type?></td><td><?=$item?></td></tr>
				<?

				}
			/** Is this a VAR directive? ***/
			else if (preg_match("/var\s+([^\s]+)\s+([^\s]+)/", $line, $matches))
				{
				$type = "Variable";
				$varname = trim($matches[1]);
				$varvalue = trim($matches[2]);
				$item = $matches[0];
				//print "<br><B>FOUND -&gt;</B> config reference: $alias $definition\n";
				$result = StoreVar($varname,$varvalue);
				?>
				<tr class="bg2"><td nowrap align="center" style="color:Green"><B><?=$result?></B></td><td nowrap><?=$type?></td><td><?=$item?></td></tr>
				<?

				}
				
			}
		}	
		
	?>
	</table>
	</td></tr></table>
	<?
	}

	


function ProcessConfigFile($filename)
	{
	/*** Open file for reading ***/
	if($handle = fopen($filename, "r"))
		{
		$buffer = "";
	
		/*** Read entire file ***/
		while (!feof($handle))
			{
			$buffer .= fgets($handle, 4096);
			}
	
		//print "<pre>$buffer</pre>\n";
	
		/*** Remove Line feeds (if any) ***/
		$buffer = preg_replace("/\r/sm","",$buffer);
		/*** Concatonate lines ending in "\" ***/
		$buffer = preg_replace("/\\\\(\s+)?\n/sm"," ",$buffer);
	
		/*** Split file into array of lines ***/
		$lines = explode("\n",$buffer);
	
		/*** Add Configs to database ***/
		InsertDirectives($lines);
	
		fclose($handle);
		}
	else
		{
		LogEvent("Error: failed to open file: $filename");
		}
	}

	
	
	
	
	
	
	
	
	
	
	
function ProcessRuleNoteFiles($filelist)
	{

	global $db;
	

	
	
	?>
	<table border="0" class="combo1"><tr><td>
	<table border="0" cellspacing="1">
	<tr><th colspan="3" class="combo1">Imported Rule Notes</th></tr>
	<tr class="combo2"><th align="center">Action</th><th>Rule SID</th><th>Comments</th></tr>
	<?
	

	
	
	foreach($filelist as $filename)
		{
		
		preg_match("/\/(\d+).txt/",$filename,$matches);
		$sid = $matches[1];		

		/*** Open file for reading ***/
		$handle = fopen($filename, "r");
		$buffer = "";
		
		/*** Read entire file ***/
		while (!feof($handle))
			{
			$buffer .= fgets($handle, 4096);
			}
	
			
		$sql =	"UPDATE		TBL_RULES ".
				"SET	".
				"	notes = '".mysql_escape_string($buffer)."' ".
				" WHERE sid = '".$sid."'";
		$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
		$count = $db->affectedRows();
	
		if($count >= 1)
			{
			$color="Green";
			$action="Imported";
			$comments = "Added comments to rule record.";
			}
		else
			{
			$color="Red";
			$action="Skipped";
			$comments = "Cannot add comments. Rule does appear to exist in the Library -or- no change in update.";
			LogEvent("Warning: SID[$sid] $comments");
			}
		
			?>
			<tr class="bg2"><td nowrap align="center" style="color:<?=$color?>"><B><?=$action?></B></td><td nowrap><?=$sid?></td><td><?=$comments?></td></tr>
			<?
	
		fclose($handle);
		
		
		
		}
	
	
	

	
	
	?>
	</table>
	</td></tr></table>
	<?
	
	}
	
	
	
	

?>

	