<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

include_once("../conf/conf.php");
include_once("../lib/func_GenBarnConf.php");
include_once("../lib/func_GenSnortConf.php");
include_once("../lib/func_curl_error.php");
include_once("../lib/func_GenToken.php");
include_once("../lib/func_gen_sid-msg.php");
include_once("../lib/func_ReserveNextID.php");
include_once("../lib/func_Log.php");

$response = "";
$reply = "";
$connected = "0";


/*** Include PEAR DB wrapper functions ***/
require_once( "DB.php" );

/*** Open Persistant Database Conection ***/
$GBL["dbdsn"] = $GBL["dbtype"] . "://" . $GBL["dbuser"] . ":" . $GBL["dbpasswd"] . "@" . $GBL["dbhost"] . "/" . $GBL["dbname"];	// DSN String
$db = DB::connect($GBL["dbdsn"],false); if (DB::isError($db)) { die ($db->getMessage());}


/*** Get the sensor ID number ***/
$sensorid = $_SERVER['argv'][1];
$action = $_SERVER['argv'][2];
//print "Sensor = ".$sensorid."\n";


/*** Clear the connection bit in monitor cache DB ***/
Reset_Connect_Status($sensorid,"0");

/*** Get Sensor details ***/
$sql = "select s.*, sc.*, bc.* FROM TBL_SENSORS as s".
	" LEFT JOIN TBL_SNORT_CTRL as sc ON s.snort_ctrl=sc.id".
	" LEFT JOIN TBL_BARN_CTRL as bc ON s.barn_ctrl=bc.id".
	" WHERE s.id =" . $sensorid;
$rsSensorCTRL = $db->query($sql); if (DB::isError($rsSensorCTRL)) { die ($rsSensorCTRL->getdebugInfo());}
$row = $rsSensorCTRL->fetchRow(DB_FETCHMODE_ASSOC);		
$temp_method 		= ($row['protocol'] == 1 ? "https" : "http" );
$temp_name 			= $row['name'];
$temp_active 		= ($row['active'] == 1 ? "checked" : ""  );
$temp_ip 			= $row['ip'];	
$temp_port 			= $row['port'];
$temp_userid 		= $row['userid'];
$temp_passwd 		= $row['passwd'];
$temp_int 			= $row['interface'];
$temp_conf_path 	= $row['conf_path'];
$temp_interface		= $row['interface'];
$temp_conf_path		= $row['conf_path'];
$temp_sensorsigmsg	= $row['sigmsg'];
$temp_snort_args	= $row['snort_args'];
$temp_switch_d = $row['switch_d'];
$temp_switch_f = $row['switch_f'];
$temp_switch_w = $row['switch_w'];
$temp_barn_args = $row['args'];
$temp_switch_X = $row['switch_X'];



$rsSensorCTRL->free();



LogEvent("Sensor Control[$sensorid]: action: $action");


/*** ############################################ Snort Start ***/
if($action == "snort_start")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -s -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=start_snort\"";
	$command .= " -F \"int=".$temp_int."\"";
	$command .= " -F \"path=".$temp_conf_path."\"";
	/* Add switches if not empty */
	$command .= ($temp_snort_args != "" ?  " -F \"args=".$temp_snort_args."\"" : "" );
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	/*** Execute the command ***/
	//print "<PRE>" .$command . "</PRE>\n\n\n";
	$output = array();
	exec($command,$output,$resultcode);
	
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line . "\n"; }
		
		/*** Check if Barnyard was actually started and record the PID ***/
		if (preg_match("/Successfully[^P]+PID\s(\d+)/", $response, $matches))
			{
			$snort_pid = $matches[1];
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_connect = '1', ".
			"mon_snortproc = '$snort_pid' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		
		}
	//print $command . "<BR>". $response;exit(1);

	}
/*** ############################################ Snort Stop ***/
elseif($action == "snort_stop")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -s -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=stop_snort\"";
	$command .= " -F \"int=".$temp_int."\"";
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line . "\n"; }
		
		/*** Check if Barnyard was actually Stopped ***/
		if (preg_match("/Snort successfully stopped/", $response, $matches))
			{
			$snort_pid = "0";
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_connect = '1', ".
			"mon_snortproc = '$snort_pid' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}
	}
	
/*** ############################################ Snort Reset ***/
elseif($action == "snort_reset")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -s -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=reset_snort\"";
	$command .= " -F \"int=".$temp_int."\"";
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line . "\n"; }
		}
	}
	
/*** ############################################ Snort Info ***/
elseif($action == "snort_info")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -s -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=snort_info\"";
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line . "\n"; }
		}	
	}

/*** ############################################ Snort Push ***/
elseif($action == "snort_push")
	{
	GenSnortConf($sensorid,$snort_conf,$snort_conf_MD5);
		
	/*** Dump snort file to a temp file ***/
	$filename = "/tmp/snortsms_" . GenToken(12) . ".tmp";
	$handle = fopen($filename, "a");
	fwrite($handle,$snort_conf);
	fclose($handle);

	$command = $GBL['curl']." -k -S -s --connect-timeout ".
		$GBL['curltimeout']." -F \"path=".$temp_conf_path."\" -F \"int=".$temp_interface."\" -F \"ac=save_snort\" -F \"MD5=".$snort_conf_MD5."\" -F content=@\"".$filename."\" ";
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
		
		

	//print $command . "\n\n\n";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response .= "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		unlink($filename);
		
		foreach($output as $line) { $response .= $line . "\n"; }
	
		/*** Check if Snort config was actually push ***/
		if (preg_match("/Push snort config Successful/", $response, $matches))
			{
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".	
			"mon_snortsync = '1', ".
			"mon_connect = '1' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}

	/*** sig-msg map support ***/
	if ( $temp_sensorsigmsg == 1 )
		{
		$sig_msg_map = Gen_sid_msg($sensorid);
		/*** Dump file to a temp file ***/
		$filename = "/tmp/snortsms_" . GenToken(12) . ".tmp";
		$handle = fopen($filename, "a");
		fwrite($handle,$sig_msg_map);
		fclose($handle);
	
		$command = $GBL['curl']." -k -S -s --connect-timeout ".$GBL['curltimeout']." -F \"path=".$temp_conf_path."\" -F \"int=".$temp_interface."\" -F \"ac=save_sigmsg\" -F content=@\"".$filename."\" ";
		$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
		//print $command . "\n\n\n";
		exec($command,$output2,$resultcode);
		if($resultcode != 0)
			{
			$curl_msg = Get_curl_error($resultcode);
			$response .= "[SnortSMS] $curl_msg\n";	
			}
		else
			{
			$connected = 1;
			unlink($filename);
			foreach($output2 as $line) { $response .= $line . "\n"; }
			}
		}

	
	}

/*** ############################################ Barn Start ***/
elseif($action == "barn_start")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=start_barn\"";
	$command .= " -F \"int=".$temp_int."\"";
	$command .= " -F \"path=".$temp_conf_path."\"";
	$command .= " -F \"sw_s=".$temp_conf_path."/SMS_sid-msg.".$temp_int.".map\"";
	/* Add switches if not empty */
	$command .= ($temp_switch_d != "" ?  " -F \"sw_d=".$temp_switch_d."\"" : "" );
	$command .= ($temp_switch_f != "" ?  " -F \"sw_f=".$temp_switch_f."\"" : "" );
	$command .= ($temp_switch_w != "" ?  " -F \"sw_w=".$temp_switch_w."\"" : "" );
	$command .= ($temp_barn_args != "" ?  " -F \"args=".$temp_barn_args."\"" : "" );
	$command .= ($temp_switch_X != "" ?  " -F \"sw_X=".$temp_switch_X."\"" : "" );
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line; }
		// print "<P>COMMAND<BR>$command</p>\n";print "<P>RESPONSE<BR>$response</p>\n";exit(1);
		
		/*** Check if Barnyard was actually started and record the PID ***/
		if (preg_match("/Successfully[^P]+PID\s(\d+)/", $response, $matches))
			{
			$barn_pid = $matches[1];
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_connect = '1', ".
			"mon_barnproc = '$barn_pid' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}
	}
	
/*** ############################################ Barn Stop ***/
elseif($action == "barn_stop")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -s -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=stop_barn\"";
	$command .= " -F \"int=".$temp_int."\"";
	$command .= ($temp_switch_X != "" ?  " -F \"sw_X=".$temp_switch_X."\"" : "" );
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line; }
			
		/*** Check if Barnyard was actually Stopped ***/
		if (preg_match("/Barnyard successfully stopped/", $response, $matches))
			{
			$barn_pid = "0";
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_connect = '1', ".
			"mon_barnproc = '$barn_pid' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}
	}
	
/*** ############################################ Barn Reset ***/
elseif($action == "barn_reset")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -s -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=reset_barn\"";
	$command .= " -F \"int=".$temp_int."\"";
	$command .= ($temp_switch_X != "" ?  " -F \"sw_X=".$temp_switch_X."\"" : "" );
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line . "\n"; }
		}
	}
	
/*** ############################################ Barn Info ***/
elseif($action == "barn_info")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -s -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=barn_info\"";
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line . "\n"; }
		}
	}
	
/*** ############################################ Barn Push ***/
elseif($action == "barn_push")
	{
	GenBarnConf($sensorid,$barn_conf,$barn_conf_MD5);
	
	/*** Dump barn file to a temp file ***/
	$tempfile = "/tmp/snortsms_" . GenToken(12) . ".tmp";
	$handle = fopen($tempfile, "a");
	fwrite($handle,$barn_conf);
	fclose($handle);
	
	$command = $GBL['curl']." -k -S -s --connect-timeout ".$GBL['curltimeout']." -F \"ac=save_barn\" -F \"path=".$temp_conf_path."\" -F \"int=".$temp_interface."\" -F \"MD5=".$barn_conf_MD5."\" -F content=@\"".$tempfile."\" ";
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	
	//print $command . "\n\n\n";
	//exit(1);
	$output="";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		unlink($tempfile);	
		$response = ""; foreach($output as $line) { $response .= $line . "\n"; }
	
		/*** Check if Barnyard config was actually push ***/
		if (preg_match("/Push barnyard config Successful/", $response, $matches))
			{
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".	
			"mon_barnsync = '1' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}
	
	}
/*** ############################################ System Load Averages ***/
elseif($action == "check_uptime")
	{
	/*** Prep the CURL command ***/
	$command = $GBL['curl']." -k -S -s -m 20 --connect-timeout ".$GBL['curltimeout']." -F \"ac=check_uptime\"";
	/* finish it up */
	$command .= " ".$temp_method."://".$temp_userid.":".$temp_passwd."@".$temp_ip.":".$temp_port."/snortsms/agent_mime.cgi";
	exec($command,$output,$resultcode);
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $curl_msg\n";	
		}
	else
		{
		$connected = 1;
		$response = ""; foreach($output as $line) { $response .= $line . "\n"; }		
		
		/*** Get uptime info ***/
		if (preg_match("/load/", $response, $matches))
			{ 
			$mon_uptime = $response;
			
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_uptime = '".$mon_uptime."' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		

		}	
	}
	
	
	
	
	
	
	
	
	
	
	
/*** Restore the connection bit in monitor cache DB ***/
Reset_Connect_Status($sensorid,$connected);
	
	
LogEvent("Sensor Control[$sensorid]: response: $response");
	
print $response;
exit(0);
	


	
?>